<template>
    <div class="container-fluid">
        <div class="row">
            <h1 class="font-weight-normal py-3 pl-3">{{title}}</h1>
        </div>
        <div class="row">
            <div class="col-12">
                <div v-if="isLoading" class="article-preview">Loading articles...</div>
                <div v-else>
                    <div v-if="articles.length === 0" class="article-preview">
                        No articles are here... yet.
                    </div>
                    <b-table small
                             :fields="fields"
                             responsive="sm"
                             id="articles-table"
                             :items="articles"
                             :per-page="itemsPerPage"
                             :current-page="1"
                             :head-variant="'light'"
                    >
                        <template v-slot:cell(index)="data">
                            {{ data.index + 1 }}
                        </template>
                        <template v-slot:cell(author)="data">
                            {{ data.value.username }}
                        </template>
                        <template v-slot:cell(tagList)="data">
                            {{ data.value.toString() }}
                        </template>
                        <template v-slot:cell(body)="data">
                            {{ data.value.split(' ').slice(0, 20).join(' ') }}
                        </template>
                        <template v-slot:cell(createdAt)="data">
                            {{ formatDate(data.value) }}
                        </template>
                        <template v-slot:cell(slug)="{ item, value }">
                            <b-dropdown v-if="currentUser.username === item.author.username" variant="info" right text="...">
                                <b-dropdown-item @click="routeToArticle(value)" class="text-dark text-decoration-none">
                                    <router-link class="100" :to="'/articles/edit/' + value ">Edit
                                    </router-link>
                                </b-dropdown-item>
                                <b-dropdown-item
                                        @click="$bvModal.show('deleteModal'), selectedArticleSlug = value">Delete
                                </b-dropdown-item>
                            </b-dropdown>
                            <div v-else>

                            </div>
                        </template>
                    </b-table>
                    <b-pagination
                            v-model="currentPage"
                            :total-rows="articlesCount"
                            :per-page="itemsPerPage"
                            aria-controls="articles-table"
                            align="center"
                    ></b-pagination>
                </div>
            </div>
        </div>
        <div class="row">
            <div>
                <b-modal id="deleteModal" title="Delete Article">
                    <p>Are you sure to delete Article?</p>
                    <template v-slot:modal-footer="{ ok, cancel, hide }">
                        <b-button size="sm" variant="outline-secondary" @click="cancel()">
                            No
                        </b-button>
                        <b-button size="sm" variant="danger" @click="ok(), deleteArticle()">
                            Yes
                        </b-button>
                    </template>
                </b-modal>
            </div>
        </div>
    </div>
</template>

<script>
    import {mapGetters} from "vuex";
    import {FETCH_ARTICLES, ARTICLE_DELETE} from "../store/actions.type";
    import {default as format} from "date-fns/format";


    export default {
        name: "ArticleList",
        components: {},
        props: {
            itemsPerPage: {
                type: Number,
                required: false,
                default: 10,
                title: ''
            }
        },
        data() {
            return {
                currentPage: 1,
                fields: [
                    {key: 'index', label: "#"},
                    'title',
                    'author',
                    {key: 'tagList', label: 'Tags'},
                    {key: 'body', label: 'Excerpt'},
                    {key: 'createdAt', label: 'Created'},
                    {key: 'slug', label: ''}
                ],
                selectedArticleSlug: ''
            };
        },
        created() {
            this.title = this.$route ? this.getFields(this.$route.meta) : null;
        },
        computed: {
            listConfig() {
                const filters = {
                    offset: (this.currentPage - 1) * this.itemsPerPage,
                    limit: this.itemsPerPage
                };
                return {
                    filters
                };
            },
            pages() {
                if (this.isLoading || this.articlesCount <= this.itemsPerPage) {
                    return [];
                }
                return [
                    ...Array(Math.ceil(this.articlesCount / this.itemsPerPage)).keys()
                ].map(e => e + 1);
            },
            ...mapGetters(["articlesCount", "isLoading", "articles", "currentUser"])
        },
        watch: {
            currentPage(newValue) {
                this.listConfig.filters.offset = (newValue - 1) * this.itemsPerPage;
                this.fetchArticles();
            }
        },
        mounted() {
            this.fetchArticles();
        },
        methods: {
            fetchArticles() {
                this.$store.dispatch(FETCH_ARTICLES, this.listConfig);
            },
            formatDate(date) {
                return format(new Date(date), "MMM d, yyyy");
            },
            routeToArticle(slug) {
                this.$router.push('/articles/edit/' + slug);
            },
            async deleteArticle() {
                await this.$store.dispatch(ARTICLE_DELETE, this.selectedArticleSlug);
                this.fetchArticles();
            },
            getFields: (meta) => {
                return meta.title;
            }
        }
    };
</script>
<style>
    thead tr th {
        padding: 8px !important;
    }
    tbody tr td {
        padding: 13px !important;
        vertical-align: middle !important;
    }
    .table-responsive-sm {
        overflow-x: auto;
    }
</style>